<template>
    <div>
        <h6 id="maisvendidos" class="q-ma-none q-mx-sm q-mt-md text-bold text-uppercase">Mais Vendidos</h6>
        <div class="row q-gutter-md" v-if="isLoading">
            <div class="col-12 col-md">
                <q-skeleton width="100%" height="100px" />
            </div>
            <div class="col-12 col-md">
                <q-skeleton width="100%" height="100px" />
            </div>
        </div>
        <div v-else class="row">
            <div v-for="(maisvendido, index) in maisvendidos" :key="index" class="col-12 col-md-6 q-pa-none q-px-xs q-pb-sm">
                <q-item class="bg-grey-3 shadow-1" :style="{ borderRadius: $q.platform.is.desktop ? '5px' : '' }">
                    <q-item-section avatar :style="{ width: '100% !important' }">
                        <div v-if="$q.platform.is.desktop" class="row full-width">
                            <div class="col-4">
                                <q-img
                                    @error="loadDefaultProductImage(index)"
                                    :style="{ borderRadius: '5px' }" width="180px" height="120px" no-native-menu
                                    :src="maisvendido.src_image"
                                >
                                    <div class="absolute-bottom text-subtitle1 text-center">
                                        <h6 class="q-ma-none text-bold">{{ parseFloat(maisvendido.preco_unidade_venda).toLocaleString('pt-BR', { style: 'currency', currency: 'BRL' }) }}</h6>
                                    </div>
                                </q-img>
                            </div>
                            <div class="col-8 q-px-sm">
                                <h6 class="q-ma-none text-bold">{{ maisvendido.descricao_geral }}</h6>
                                <p class="q-ma-none text-grey-7 ellipsis-3-lines">
                                    {{ maisvendido.observacoes }}
                                </p>
                            </div>
                        </div>

                        <div v-else class="row full-width">
                            <div class="col-3 relative-position">
                                <q-img
                                    @error="loadDefaultProductImage(index)"
                                    :style="{ borderRadius: '5px' }" width="70px" height="70px" no-native-menu
                                    :src="maisvendido.src_image"
                                />
                                <div class="absolute bg-white text-center" :style="{ bottom: '0px', width: '70px', borderRadius: '0px 0px 5px 5px' }">
                                    <p class="q-ma-none text-bold">{{ parseFloat(maisvendido.preco_unidade_venda).toLocaleString('pt-BR', { style: 'currency', currency: 'BRL' }) }}</p>
                                </div>
                            </div>
                            <div class="col-9 q-pl-md">
                                <p class="q-ma-none text-bold ellipsis">{{ maisvendido.descricao_geral }}</p>
                                <p class="q-ma-none text-grey-7 ellipsis-3-lines" :style="{ fontSize: '10px' }">
                                    {{ maisvendido.observacoes }}
                                </p>
                            </div>
                        </div>
                    </q-item-section>
                </q-item>
            </div>
        </div>
    </div>
</template>

<script setup>
import { useSearchStore } from "../stories/searchStore";
import { useStoreInfo } from "../stories/storeInfo";
import { ref, watch } from 'vue';
import api from '../axios/api'

const emit = defineEmits(['noData']);
const storeInfo = useStoreInfo();
const searchStore = useSearchStore();
const maisvendidos = ref([]);
const originData = ref([]);
const isLoading = ref(false);
async function loadBestSellers () {
    isLoading.value = true;
    const result = await api.get('/api/products/best-sellers', {
        transformResponse: api.defaults.transformResponse.concat(function (data, headers) {
            Object.keys(data.data).forEach(function (index) {
                data.data[index].src_image = `https://api.flex.fsbr.com.br/uploads/${String(data.data[index].codigo_filial).padStart(5, '0')}_${String(data.data[index].codigo_produtos).padStart(10, '0')}.jpg`
            });
            return data;
        })
    }).catch(error => error).finally(() => isLoading.value = false)

    if (result.error || result.data.data.length === 0) emit('noData')
    maisvendidos.value = result.data.data
    originData.value = result.data.data
}
function loadDefaultProductImage (index) {
    maisvendidos.value[index].src_image = `${import.meta.env.VITE_APP_URL}/img/default.png`
}

watch(() => storeInfo.storeInfo, (newValue) => {
    if(newValue) loadBestSellers();
}, { deep: true, immediate: true })

watch(() => searchStore.searchTerm, (newValue) => {
    maisvendidos.value = originData.value.filter(item => item.descricao_geral.toLowerCase().includes(newValue))
})
</script>
